Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  SolidWorks
  SketchManager.Create3PointArc fehlerhaftes Verhalten in SolidWorks 2017.

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   SketchManager.Create3PointArc fehlerhaftes Verhalten in SolidWorks 2017. (447 mal gelesen)
pklemm
Mitglied
Dipl. Ing. Maschinenbau

Sehen Sie sich das Profil von pklemm an!   Senden Sie eine Private Message an pklemm  Schreiben Sie einen Gästebucheintrag für pklemm

Beiträge: 8
Registriert: 07.05.2009

erstellt am: 30. Dez. 2019 14:56    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


Bild3.gif


Zahn.txt

 
Mir ist unklar, warum je nach aktueller Bildschirmskalierung die Funktion SketchManager.Create3PointArc unterschiedliche Ergebnisse liefert. Anbei ein Beispiel:
Die Datei Zahn.bas enthält einen Evolventenzahngeometrie, die im SolidWorks nach VBA importiert werden kann, um eine Makrodatei (.swp) zu erzeugen.
Sie enthält 2 Kreisbögen und ein paar Splines.
Wird eine Skizze geöffnet und das Makro darin ausgeführt, hängt das Ergebnis von der aktuellen Zoom-Einstellung ab: Bild1b zeigt das Ergebnis, wenn die Zahngeometrie sehr klein im Verhältnis zum Anzeigebereich des Bildschirms ist (wie Bild1), Bild2 mit etwas anderem Zoomfaktor und im Bild3 wenn der Zoomfaktor etwa in der gleichen Größenordnung liegt wie die Abmessungen der Geometrie. Im ersten und zweiten Fall stimmen die Endpunktkoordinaten und der Kreisdurchgangspunkt auch nicht mit den Makrowerten überein, wenn man die Kurvensegmente in der Skizze untersucht. Hat jemand dafür eine Erklärung oder noch besser eine Lösung?

Bild1: Weit weg

Bild1b: Herangezoomtes Bild1

Bild2: Nicht ganz so weit weg (immer noch falsch)

Bild3: Nahe Skalierung bei Makroausführung. So sollte es immer aussehen


Auszug aus dem Code von Zahn.bas:

Option Explicit

Dim swApp As Object
Dim Part As Object
Dim pointArray As Variant
Dim points() As Double

Sub main()
        Set swApp = Application.SldWorks
        Set Part = swApp.ActiveDoc
       
        Part.ClearSelection2 True
       
        With Part.SketchManager

                .Create3PointArc 9.63957183508436E-04, 5.62592072619751E-02, 0, 3.58469958757168E-04, 5.63228465336958E-02, 0, 6.61978757874054E-04, 5.62983071633673E-02, 0
                ReDim points(0 To 17) As Double
                points(0) = 3.58469958757168E-04
                points(1) = 5.63228465336958E-02
                points(2) = 0
                points(3) = 2.64892600427464E-04
                points(4) = 5.63580709538893E-02
                points(5) = 0
                points(6) = 1.83893473583847E-04
                points(7) = 5.64518565985445E-02
                points(8) = 0
                points(9) = 1.24482998019793E-04
                points(10) = 5.66020073525614E-02
                points(11) = 0
                points(12) = 9.53649174349324E-05
                points(13) = 5.68052421003048E-02
                points(14) = 0
                points(15) = 1.04819017198107E-04
                points(16) = 5.70572328560805E-02
                points(17) = 0
                pointArray = points
                .CreateSpline ((pointArray))
               
...

Solidworks API Create3PointArc

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

elmarklammer
Mitglied
Konstrukteur``


Sehen Sie sich das Profil von elmarklammer an!   Senden Sie eine Private Message an elmarklammer  Schreiben Sie einen Gästebucheintrag für elmarklammer

Beiträge: 25
Registriert: 19.12.2002

SW 2016 SP5, INV 2013, NVIDIA K2000D, BOXX W4170
INTEL CORE I7-4770K WIN 7 PRO

erstellt am: 01. Jan. 2020 14:52    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für pklemm 10 Unities + Antwort hilfreich

Check out AddToDB in API help

https://forum.solidworks.com/thread/82265

That might be the reason

------------------
elmar

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

pklemm
Mitglied
Dipl. Ing. Maschinenbau

Sehen Sie sich das Profil von pklemm an!   Senden Sie eine Private Message an pklemm  Schreiben Sie einen Gästebucheintrag für pklemm

Beiträge: 8
Registriert: 07.05.2009

erstellt am: 02. Jan. 2020 10:17    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Thank you for that tip.
Yes, this was the solution.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz